using FarPoint.Win.Spread;
using System.Data;
using System.Diagnostics;

namespace FilterModify
{
    public partial class Form1 : Form
    {
        public IRowFilter rowFilter;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable flightDetails = new DataTable("FlightDetails");
            flightDetails.Columns.Add("Passenger Name");
            flightDetails.Columns.Add("Department");
            flightDetails.Columns.Add("Ticket Type");
            flightDetails.Columns.Add("Flight ID");
            flightDetails.Columns.Add("Flight Date");
            flightDetails.Columns.Add("Flight Src");
            flightDetails.Columns.Add("Flight Dest");
            flightDetails.Rows.Add("Mark", "Sales", "Economy", 7855, new DateTime(2021, 10, 11).ToShortDateString(), "New York", "Tokyo");
            flightDetails.Rows.Add("Sophie", "Services", "Economy", 7426, new DateTime(2021, 10, 12).ToShortDateString(), "London", "Venice");
            flightDetails.Rows.Add("Oliver", "Finance", "Business", 7641, new DateTime(2021, 10, 15).ToShortDateString(), "New Delhi", "Moscow");
            flightDetails.Rows.Add("James", "R&D", "Economy", 7293, new DateTime(2021, 10, 18).ToShortDateString(), "Beijing", "Dubai");
            flightDetails.Rows.Add("Emma", "Marketing", "Business", 7117, new DateTime(2021, 10, 20).ToShortDateString(), "Paris", "Seoul");

            fpSpread1.DataSource = flightDetails;

            rowFilter = fpSpread1.ActiveSheet.RowFilter;
            if (rowFilter == null)
            {
                rowFilter = new HideRowFilter(fpSpread1.ActiveSheet);
                fpSpread1.ActiveSheet.RowFilter = rowFilter;
            }

            fpSpread1.ActiveSheet.AddRows(0, 1);
            rowFilter.UnfilteredRows = new int[] { 0 };
            fpSpread1.EditChange += FpSpread1_EditChange;
        }

        private void FpSpread1_EditChange(object sender, EditorNotifyEventArgs e)
        {
            if (e.Row == 0)
            {
                Debug.WriteLine("Called...");
                for (int i = 0; i < fpSpread1.ActiveSheet.ColumnCount; i++)
                {
                    string text = fpSpread1.ActiveSheet.Cells[0, i].Text;
                    if (text != String.Empty)
                    {
                        FilterCondition fcd = new FilterCondition(CustomFilterOperatorType.Equal, "*" + text + "*");
                        CustomFilterItem activeFilter = new CustomFilterItem(fcd, null, true);
                        activeFilter.SheetView = fpSpread1.ActiveSheet;
                        FilterColumnDefinition filterColumnDefinition = new FilterColumnDefinition(i, FilterListBehavior.Custom);
                        filterColumnDefinition.Filters.Add(activeFilter);
                        rowFilter.ColumnDefinitions.Add(filterColumnDefinition);
                        fpSpread1.ActiveSheet.AutoFilterColumn(i, activeFilter.DisplayName, 0);
                    }
                    else
                    {
                        fpSpread1.ActiveSheet.AutoFilterColumn(i, null, 0);
                    }
                }
            }
        }
    }
}
